ompi/mca/allocator/bucket/allocator_bucket_alloc.h File Reference.TH "ompi/mca/allocator/bucket/allocator_bucket_alloc.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/mca/allocator/bucket/allocator_bucket_alloc.h \- A generic memory bucket allocator. 
.SH SYNOPSIS
.br
.PP
\fC#include <stdlib.h>\fP
.br
\fC#include <string.h>\fP
.br
\fC#include 'opal/threads/mutex.h'\fP
.br
\fC#include 'opal/class/opal_object.h'\fP
.br
\fC#include 'mca/allocator/allocator.h'\fP
.br

.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef \fBmca_allocator_bucket_chunk_header_t\fP \fBmca_allocator_bucket_chunk_header_t\fP"
.br
.RI "\fITypedef so we don't have to use struct. \fP"
.ti -1c
.RI "typedef \fBmca_allocator_bucket_segment_head_t\fP \fBmca_allocator_bucket_segment_head_t\fP"
.br
.RI "\fITypedef so we don't have to use struct. \fP"
.ti -1c
.RI "typedef \fBmca_allocator_bucket_bucket_t\fP \fBmca_allocator_bucket_bucket_t\fP"
.br
.RI "\fITypedef so we don't have to use struct. \fP"
.ti -1c
.RI "typedef \fBmca_allocator_bucket_t\fP \fBmca_allocator_bucket_t\fP"
.br
.RI "\fITypedef so we don't have to use struct. \fP"
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "\fBmca_allocator_bucket_t\fP * \fBmca_allocator_bucket_init\fP (\fBmca_allocator_base_module_t\fP *mem, int num_buckets, \fBmca_allocator_base_component_segment_alloc_fn_t\fP get_mem_funct, \fBmca_allocator_base_component_segment_free_fn_t\fP free_mem_funct)"
.br
.RI "\fIInitializes the mca_allocator_bucket_options_t data structure for the passed parameters. \fP"
.ti -1c
.RI "void * \fBmca_allocator_bucket_alloc\fP (\fBmca_allocator_base_module_t\fP *mem, size_t size, mca_mpool_base_registration_t **registration)"
.br
.RI "\fIAccepts a request for memory in a specific region defined by the mca_allocator_bucket_options_t struct and returns a pointer to memory in that region or NULL if there was an error. \fP"
.ti -1c
.RI "void * \fBmca_allocator_bucket_alloc_align\fP (\fBmca_allocator_base_module_t\fP *mem, size_t size, size_t alignment, mca_mpool_base_registration_t **registration)"
.br
.RI "\fIAccepts a request for memory in a specific region defined by the mca_allocator_bucket_options_t struct and aligned by the specified amount and returns a pointer to memory in that region or NULL if there was an error. \fP"
.ti -1c
.RI "void * \fBmca_allocator_bucket_realloc\fP (\fBmca_allocator_base_module_t\fP *mem, void *ptr, size_t size, mca_mpool_base_registration_t **registration)"
.br
.RI "\fIAttempts to resize the passed region of memory into a larger or a smaller region. \fP"
.ti -1c
.RI "void \fBmca_allocator_bucket_free\fP (\fBmca_allocator_base_module_t\fP *mem, void *ptr)"
.br
.RI "\fIFrees the passed region of memory. \fP"
.ti -1c
.RI "int \fBmca_allocator_bucket_cleanup\fP (\fBmca_allocator_base_module_t\fP *mem)"
.br
.RI "\fIFrees all the memory from all the buckets back to the system. \fP"
.ti -1c
.RI "int \fBmca_allocator_bucket_finalize\fP (\fBmca_allocator_base_module_t\fP *mem)"
.br
.RI "\fICleanup all resources held by this allocator. \fP"
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "OMPI_COMP_EXPORT \fBmca_allocator_base_component_t\fP \fBmca_allocator_bucket_component\fP"
.br
.in -1c
.SH "Detailed Description"
.PP 
A generic memory bucket allocator. 


.SH "Function Documentation"
.PP 
.SS "void* mca_allocator_bucket_alloc (\fBmca_allocator_base_module_t\fP * mem, size_t size, mca_mpool_base_registration_t ** registration)"
.PP
Accepts a request for memory in a specific region defined by the mca_allocator_bucket_options_t struct and returns a pointer to memory in that region or NULL if there was an error. 
.PP
\fBParameters:\fP
.RS 4
\fImem\fP A pointer to the appropriate struct for the area of memory. 
.br
\fIsize\fP The size of the requested area of memory
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIPointer\fP to the area of memory if the allocation was successful 
.br
\fINULL\fP if the allocation was unsuccessful 
.RE
.PP

.SS "void* mca_allocator_bucket_alloc_align (\fBmca_allocator_base_module_t\fP * mem, size_t size, size_t alignment, mca_mpool_base_registration_t ** registration)"
.PP
Accepts a request for memory in a specific region defined by the mca_allocator_bucket_options_t struct and aligned by the specified amount and returns a pointer to memory in that region or NULL if there was an error. 
.PP
\fBParameters:\fP
.RS 4
\fImem\fP A pointer to the appropriate struct for the area of memory. 
.br
\fIsize\fP The size of the requested area of memory 
.br
\fIalignment\fP The requested alignment of the new area of memory. This MUST be a power of 2.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIPointer\fP to the area of memory if the allocation was successful 
.br
\fINULL\fP if the allocation was unsuccessful 
.RE
.PP

.SS "int mca_allocator_bucket_cleanup (\fBmca_allocator_base_module_t\fP * mem)"
.PP
Frees all the memory from all the buckets back to the system. 
.PP
Note that this function only frees memory that was previously freed with \fBmca_allocator_bucket_free()\fP.
.PP
\fBParameters:\fP
.RS 4
\fImem\fP A pointer to the appropriate struct for the area of memory.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fINone\fP .RE
.PP

.SS "int mca_allocator_bucket_finalize (\fBmca_allocator_base_module_t\fP * mem)"
.PP
Cleanup all resources held by this allocator. 
.PP
\fBParameters:\fP
.RS 4
\fImem\fP A pointer to the appropriate struct for the area of memory.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fINone\fP .RE
.PP

.SS "void mca_allocator_bucket_free (\fBmca_allocator_base_module_t\fP * mem, void * ptr)"
.PP
Frees the passed region of memory. 
.PP
\fBParameters:\fP
.RS 4
\fImem\fP A pointer to the appropriate struct for the area of memory. 
.br
\fIptr\fP A pointer to the region of memory to be freed
.RE
.PP
\fBReturn values:\fP
.RS 4
\fINone\fP .RE
.PP

.SS "\fBmca_allocator_bucket_t\fP* mca_allocator_bucket_init (\fBmca_allocator_base_module_t\fP * mem, int num_buckets, \fBmca_allocator_base_component_segment_alloc_fn_t\fP get_mem_funct, \fBmca_allocator_base_component_segment_free_fn_t\fP free_mem_funct)"
.PP
Initializes the mca_allocator_bucket_options_t data structure for the passed parameters. 
.PP
\fBParameters:\fP
.RS 4
\fImem\fP a pointer to the mca_allocator_t struct to be filled in 
.br
\fInum_buckets\fP The number of buckets the allocator will use 
.br
\fIget_mem_funct\fP A pointer to the function that the allocator will use to get more memory 
.br
\fIfree_mem_funct\fP A pointer to the function that the allocator will use to free memory
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIPointer\fP to the initialized mca_allocator_bucket_options_t structure 
.br
\fINULL\fP if there was an error 
.RE
.PP

.SS "void* mca_allocator_bucket_realloc (\fBmca_allocator_base_module_t\fP * mem, void * ptr, size_t size, mca_mpool_base_registration_t ** registration)"
.PP
Attempts to resize the passed region of memory into a larger or a smaller region. 
.PP
If it is unsuccessful, it will return NULL and the passed area of memory will be untouched.
.PP
\fBParameters:\fP
.RS 4
\fImem\fP A pointer to the appropriate struct for the area of memory. 
.br
\fIsize\fP The size of the requested area of memory 
.br
\fIptr\fP A pointer to the region of memory to be resized
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIPointer\fP to the area of memory if the reallocation was successful 
.br
\fINULL\fP if the allocation was unsuccessful 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
